Index: /trunk/sources/HeuristicLab.Analysis.Views/3.3/HeuristicLabAnalysisViewsPlugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.Analysis.Views/3.3/HeuristicLabAnalysisViewsPlugin.cs.frame	(revision 4888)
+++ /trunk/sources/HeuristicLab.Analysis.Views/3.3/HeuristicLabAnalysisViewsPlugin.cs.frame	(revision 4889)
@@ -30,4 +30,5 @@
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
   [PluginDependency("HeuristicLab.Core", "3.3")]
   [PluginDependency("HeuristicLab.Core.Views", "3.3")]
Index: /trunk/sources/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Tests/Properties/AssemblyInfo.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Tests/Properties/AssemblyInfo.cs	(revision 4888)
+++ /trunk/sources/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Tests/Properties/AssemblyInfo.cs	(revision 4889)
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.1.0")]
+[assembly: AssemblyFileVersion("3.3.2.0")]
Index: /trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Tests/Properties/AssemblyInfo.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Tests/Properties/AssemblyInfo.cs	(revision 4888)
+++ /trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Tests/Properties/AssemblyInfo.cs	(revision 4889)
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.1.0")]
+[assembly: AssemblyFileVersion("3.3.2.0")]
Index: /trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/Tests/Properties/AssemblyInfo.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/Tests/Properties/AssemblyInfo.cs	(revision 4888)
+++ /trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/Tests/Properties/AssemblyInfo.cs	(revision 4889)
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.1.0")]
+[assembly: AssemblyFileVersion("3.3.2.0")]
Index: /trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/Tests/Properties/AssemblyInfo.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/Tests/Properties/AssemblyInfo.cs	(revision 4888)
+++ /trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/Tests/Properties/AssemblyInfo.cs	(revision 4889)
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.1.0")]
+[assembly: AssemblyFileVersion("3.3.2.0")]
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/HeuristicLabEncodingsSymbolicExpressionTreeEncodingPlugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/HeuristicLabEncodingsSymbolicExpressionTreeEncodingPlugin.cs.frame	(revision 4888)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/HeuristicLabEncodingsSymbolicExpressionTreeEncodingPlugin.cs.frame	(revision 4889)
@@ -28,14 +28,14 @@
   [Plugin("HeuristicLab.Encodings.SymbolicExpressionTreeEncoding", "3.3.2.$WCREV$")]
   [PluginFile("HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.3.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Analysis", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Collections", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Common", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Common.Resources", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Core", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Data", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Operators", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Optimization", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Parameters", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Persistence", "3.3.1.0")]
+  [PluginDependency("HeuristicLab.Analysis", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Collections", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Common", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Common.Resources", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Core", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Data", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Operators", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Persistence", "3.3.2.0")]
   public class HeuristicLabEncodingsSymbolicExpressionTreeEncodingPlugin : PluginBase {
   }
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/Properties/AssemblyInfo.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/Properties/AssemblyInfo.cs	(revision 4888)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/Properties/AssemblyInfo.cs	(revision 4889)
@@ -52,4 +52,4 @@
 // You can specify all the values or you can default the Revision and Build Numbers 
 // by using the '*' as shown below:
-[assembly: AssemblyVersion("1.0.0.0")]
-[assembly: AssemblyFileVersion("1.0.0.0")]
+[assembly: AssemblyVersion("3.3.0.0")]
+[assembly: AssemblyFileVersion("3.3.2.0")]
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLabOptimizerPlugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLabOptimizerPlugin.cs.frame	(revision 4888)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLabOptimizerPlugin.cs.frame	(revision 4889)
@@ -39,5 +39,5 @@
   }
 
-  [Application("Optimizer", "HeuristicLab Optimizer 3.3.1.$WCREV$")]
+  [Application("Optimizer", "HeuristicLab Optimizer 3.3.2.$WCREV$")]
   internal class HeuristicLabOptimizerApplication : ApplicationBase {
     public override void Run() {
Index: /trunk/sources/HeuristicLab.Persistence/3.3/Tests/Properties/AssemblyInfo.cs
===================================================================
--- /trunk/sources/HeuristicLab.Persistence/3.3/Tests/Properties/AssemblyInfo.cs	(revision 4888)
+++ /trunk/sources/HeuristicLab.Persistence/3.3/Tests/Properties/AssemblyInfo.cs	(revision 4889)
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.1.0")]
+[assembly: AssemblyFileVersion("3.3.2.0")]
Index: /trunk/sources/HeuristicLab.Problems.ArtificialAnt.Views/3.3/HeuristicLabProblemsArtificialAntViewsPlugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.Problems.ArtificialAnt.Views/3.3/HeuristicLabProblemsArtificialAntViewsPlugin.cs.frame	(revision 4888)
+++ /trunk/sources/HeuristicLab.Problems.ArtificialAnt.Views/3.3/HeuristicLabProblemsArtificialAntViewsPlugin.cs.frame	(revision 4889)
@@ -28,12 +28,12 @@
   [Plugin("HeuristicLab.Problems.ArtificialAnt.Views", "3.3.2.$WCREV$")]
   [PluginFile("HeuristicLab.Problems.ArtificialAnt.Views-3.3.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Core", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Core.Views", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Data", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Encodings.SymbolicExpressionTreeEncoding","3.3.1.0")]
-  [PluginDependency("HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views","3.3.1.0")]
-  [PluginDependency("HeuristicLab.MainForm", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Problems.ArtificialAnt", "3.3.1.0")]
+  [PluginDependency("HeuristicLab.Core", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Core.Views", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Data", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Encodings.SymbolicExpressionTreeEncoding","3.3.2.0")]
+  [PluginDependency("HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views","3.3.2.0")]
+  [PluginDependency("HeuristicLab.MainForm", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Problems.ArtificialAnt", "3.3.2.0")]
   public class HeuristicLabProblemsArtificialAntViewsPlugin : PluginBase {
   }
Index: /trunk/sources/HeuristicLab.Problems.ArtificialAnt/3.3/HeuristicLabProblemsArtificialAntPlugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.Problems.ArtificialAnt/3.3/HeuristicLabProblemsArtificialAntPlugin.cs.frame	(revision 4888)
+++ /trunk/sources/HeuristicLab.Problems.ArtificialAnt/3.3/HeuristicLabProblemsArtificialAntPlugin.cs.frame	(revision 4889)
@@ -28,14 +28,14 @@
   [Plugin("HeuristicLab.Problems.ArtificialAnt", "3.3.2.$WCREV$")]
   [PluginFile("HeuristicLab.Problems.ArtificialAnt-3.3.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Collections", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Common", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Common.Resources", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Core", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Data", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Encodings.SymbolicExpressionTreeEncoding","3.3.1.0")]
-  [PluginDependency("HeuristicLab.Operators", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Optimization", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Parameters", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Persistence", "3.3.1.0")]
+  [PluginDependency("HeuristicLab.Collections", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Common", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Common.Resources", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Core", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Data", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Encodings.SymbolicExpressionTreeEncoding","3.3.2.0")]
+  [PluginDependency("HeuristicLab.Operators", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Persistence", "3.3.2.0")]
   public class HeuristicLabProblemsArtificialAntPlugin : PluginBase {
   }
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Analyzers/FixedValidationBestScaledSymbolicRegressionSolutionAnalyzer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Analyzers/FixedValidationBestScaledSymbolicRegressionSolutionAnalyzer.cs	(revision 4888)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Analyzers/FixedValidationBestScaledSymbolicRegressionSolutionAnalyzer.cs	(revision 4889)
@@ -196,5 +196,5 @@
     [StorableHook(HookType.AfterDeserialization)]
     private void AfterDeserialization() {
-      #region compatibility remove before releasing 3.3.1
+      #region compatibility remove before releasing 3.4
       if (!Parameters.ContainsKey(EvaluatorParameterName)) {
         Parameters.Add(new LookupParameter<ISymbolicRegressionEvaluator>(EvaluatorParameterName, "The evaluator which should be used to evaluate the solution on the validation set."));
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/HeuristicLabProblemsDataAnalysisViewsPlugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/HeuristicLabProblemsDataAnalysisViewsPlugin.cs.frame	(revision 4888)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/HeuristicLabProblemsDataAnalysisViewsPlugin.cs.frame	(revision 4889)
@@ -29,17 +29,17 @@
   [PluginFile("HeuristicLab.Problems.DataAnalysis.Views-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.ALGLIB","2.5.0.0")]
-  [PluginDependency("HeuristicLab.Collections", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Common", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Core", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Core.Views", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Data", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Data.Views", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Encodings.SymbolicExpressionTreeEncoding", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.MainForm", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Optimization", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Problems.DataAnalysis", "3.3.1.0")]
-  [PluginDependency("HeuristicLab.Problems.DataAnalysis.Regression", "3.3.1.0")]
+  [PluginDependency("HeuristicLab.Collections", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Common", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Core", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Core.Views", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Data", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Data.Views", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Encodings.SymbolicExpressionTreeEncoding", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.MainForm", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Problems.DataAnalysis", "3.3.2.0")]
+  [PluginDependency("HeuristicLab.Problems.DataAnalysis.Regression", "3.3.2.0")]
   [PluginDependency("HeuristicLab.Visualization.ChartControlsExtensions", "3.3")]
   public class HeuristicLabProblemsDataAnalysisViewsPlugin : PluginBase {
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Tests/Properties/AssemblyInfo.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Tests/Properties/AssemblyInfo.cs	(revision 4888)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Tests/Properties/AssemblyInfo.cs	(revision 4889)
@@ -52,3 +52,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.1.0")]
+[assembly: AssemblyFileVersion("3.3.2.0")]
Index: /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Tests/Properties/AssemblyInfo.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Tests/Properties/AssemblyInfo.cs	(revision 4888)
+++ /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Tests/Properties/AssemblyInfo.cs	(revision 4889)
@@ -31,4 +31,4 @@
 // You can specify all the values or you can default the Revision and Build Numbers 
 // by using the '*' as shown below:
-[assembly: AssemblyVersion("1.0.0.0")]
-[assembly: AssemblyFileVersion("1.0.0.0")]
+[assembly: AssemblyVersion("3.3.0.0")]
+[assembly: AssemblyFileVersion("3.3.2.0")]
Index: /trunk/sources/HeuristicLab.Problems.VehicleRouting.Views/3.3/HeuristicLabProblemsVehicleRoutingViewsPlugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.Problems.VehicleRouting.Views/3.3/HeuristicLabProblemsVehicleRoutingViewsPlugin.cs.frame	(revision 4888)
+++ /trunk/sources/HeuristicLab.Problems.VehicleRouting.Views/3.3/HeuristicLabProblemsVehicleRoutingViewsPlugin.cs.frame	(revision 4889)
@@ -28,4 +28,5 @@
   [Plugin("HeuristicLab.Problems.VehicleRouting.Views", "3.3.2.$WCREV$")]
   [PluginFile("HeuristicLab.Problems.VehicleRouting.Views-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
   [PluginDependency("HeuristicLab.Core", "3.3")]
   [PluginDependency("HeuristicLab.Core.Views", "3.3")]
Index: /trunk/sources/HeuristicLab/3.3/Properties/AssemblyInfo.frame
===================================================================
--- /trunk/sources/HeuristicLab/3.3/Properties/AssemblyInfo.frame	(revision 4888)
+++ /trunk/sources/HeuristicLab/3.3/Properties/AssemblyInfo.frame	(revision 4889)
@@ -51,4 +51,4 @@
 //      Revision
 //
-[assembly: AssemblyVersion("3.3.1.$WCREV$")]
+[assembly: AssemblyVersion("3.3.2.$WCREV$")]
 [assembly: AssemblyFileVersion("3.3.2.$WCREV$")]
Index: /trunk/sources/HeuristicLab/3.3/Tests/Properties/AssemblyInfo.cs
===================================================================
--- /trunk/sources/HeuristicLab/3.3/Tests/Properties/AssemblyInfo.cs	(revision 4888)
+++ /trunk/sources/HeuristicLab/3.3/Tests/Properties/AssemblyInfo.cs	(revision 4889)
@@ -31,4 +31,4 @@
 // You can specify all the values or you can default the Build and Revision Numbers 
 // by using the '*' as shown below:
-[assembly: AssemblyVersion("1.0.0.0")]
-[assembly: AssemblyFileVersion("1.0.0.0")]
+[assembly: AssemblyVersion("3.3.0.0")]
+[assembly: AssemblyFileVersion("3.3.2.0")]